//Sonic Emerald Burst
addHook("AbilitySpecial", function(player)
	if player.mo.skin == "sonic"
		if not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_THOKKED)
	        player.pflags = $1 & ~PF_JUMPED
			player.mo.momz = 10*FRACUNIT
			P_Thrust(player.mo, player.mo.angle, 34*FRACUNIT)
			S_StartSound(player.mo, sfx_zoom)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $1|PF_THOKKED
			player.pflags = $1|PF_JUMPED
		end
	end
end)

//Sonic Chaos Stomp
addHook("SpinSpecial", function(player)
		if player.mo.skin == "sonic"
		if (player.mo.state == S_PLAY_JUMP)
		P_NukeEnemies(player.mo, player.mo, 100*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
		player.mo.momz = -23*FRACUNIT
		player.mo.state = S_PLAY_FALL
		end
	end
end)

//Tails Chaos Flight
addHook("SpinSpecial", function(player)
	if player.mo.skin == "tails"
		if P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_THOKKED)
	        player.pflags = $1 & ~PF_JUMPED
			player.mo.momz = 19*FRACUNIT
			player.mo.height = 5*FRACUNIT
			P_Thrust(player.mo, player.mo.angle, 34*FRACUNIT)
			S_StartSound(player.mo, sfx_zoom)
			player.mo.state = S_PLAY_FLY
			player.pflags = $1|PF_THOKKED
			player.pflags = $1|PF_JUMPED
		end
	end
end)

//Tails Emerald Thrust
addHook("SpinSpecial", function(player)
		if player.mo.skin == "tails"
		if (player.mo.state == S_PLAY_JUMP)
		P_NukeEnemies(player.mo, player.mo, 100*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
		player.mo.momz = -23*FRACUNIT
		player.mo.state = S_PLAY_FLY
		end
	end
end)

//CHUCKLES
addHook("SpinSpecial", function(player)
		if player.mo.skin == "knuckles"
		if (player.mo.state == S_PLAY_GLIDE)
		player.pflags = $1 & ~PF_JUMPED
		S_StartSound(player.mo, sfx_jump)
		player.mo.momz = 10*FRACUNIT
		player.mo.height = 15*FRACUNIT
		player.mo.state = S_PLAY_SPRING
		player.pflags = $1|PF_JUMPED
		end
	end
end)

//CHUCKLES
addHook("SpinSpecial", function(player)
		if player.mo.skin == "knuckles"
		if (player.mo.state == S_PLAY_JUMP)
		P_Thrust(player.mo, player.mo.angle, 15*FRACUNIT)
		S_StartSound(player.mo, sfx_zoom)
	    player.pflags = $1 & ~PF_JUMPED
		player.mo.momz = 19*FRACUNIT
		player.mo.height = 5*FRACUNIT
		player.mo.state = S_PLAY_JUMP
		player.pflags = $1|PF_JUMPED
		end
	end
end)